/**
 * This JavaScript file is used for dynamic manipulation 
 * of web interface and virtual 3D model.
 *
 * Here are implemented all nessesary JS functions.
 * Every function has its description.
 *
 * @author Tatiana Okonechnikova <okonetat@fel.cvut.cz>
 */
		
//-----------------------------------------------------------
// Correct resizing top line toward to navigation tab menu
//-----------------------------------------------------------
$(document).ready(function(){	
		var topbar = document.getElementById("topbar");
		var tabswidth = document.getElementById("tabs");
		var tabsoffsetwidth = tabswidth.offsetWidth;
		var windowwidth = window.innerWidth;
		var subwidth = windowwidth - tabsoffsetwidth - 5;
		var subwidthstr = subwidth + "px";
		topbar.style.width = subwidthstr;
		var tabsoffsetheight = tabswidth.offsetHeight;
		var windowheight = window.innerHeight;
		var subheight = tabsoffsetheight - 1;
		var subheightstr = subheight + "px";
		topbar.style.height = subheightstr;	
	});

//-----------------------------------------------------------
// Pop up window for link About
//-----------------------------------------------------------
function popup(url) {
	new_window = window.open(url,'name','height = 200, width = 420');
	if (window.focus) {new_window.focus()}
	return false;
}

//-----------------------------------------------------------
// Animation walk through building - switching viewpoints
// X3D node: <Viewpoint />
// @method JS setTimeout()
//-----------------------------------------------------------
function walk_through_build() {
	var view_corridor = document.getElementById("building__view_corridor");
	var view_perspect_tokamak = document.getElementById("building__view_tokamak");
	var view_default_tokamak = document.getElementById("building__view_initial");
	var view_infra = document.getElementById("building__view_ifrRoom_entrance");	
	setTimeout(function() {view_corridor.setAttribute('set_bind', 'true');}, 2000);
	setTimeout(function() {view_perspect_tokamak.setAttribute('set_bind', 'true');}, 4000);
	setTimeout(function() {view_corridor.setAttribute('set_bind', 'true');}, 7000);
	setTimeout(function() {view_infra.setAttribute('set_bind', 'true');}, 9000);
	setTimeout(function() {view_corridor.setAttribute('set_bind', 'true');}, 16000);
	setTimeout(function() {view_default_tokamak.setAttribute('set_bind', 'true');}, 20000);
}

//-----------------------------------------------------------
// Animation walks using X3D nodes: <Viewpoint />
//									<TimeSensor />
// 									<PositionInterpolator />
// 									<Route />
//-----------------------------------------------------------
function walk_from_to_infra() {
	document.getElementById('building__view_way').setAttribute('set_bind', 'true');			
	var time_way = document.getElementById('building__time_routeView');						
	time_way.setAttribute('startTime', Date.now()/1000);									
}
function walk_around_tokamak() {
	document.getElementById('building__view_around').setAttribute('set_bind', 'true');		
	var time_around = document.getElementById('building__time_animatedView');						
	time_around.setAttribute('startTime', Date.now()/1000);	
}
function walk_inside_infra() {
	document.getElementById('building__view_aroundInfr').setAttribute('set_bind', 'true');	
	var time_aroundInfr = document.getElementById('building__time_animatedView1');						
   	time_aroundInfr.setAttribute('startTime', Date.now()/1000);
}

//-----------------------------------------------------------
// Animation walk inside the chamber - switching viewpoints
// X3D node: <Viewpoint />
// @method JS setTimeout()
//-----------------------------------------------------------
function walk_inside_chamber() {
	setTimeout(function() {document.getElementById("building__view_inside_chamber01").setAttribute('set_bind', 'true');}, 1000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber02").setAttribute('set_bind', 'true');}, 2000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber03").setAttribute('set_bind', 'true');}, 3000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber04").setAttribute('set_bind', 'true');}, 4000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber05").setAttribute('set_bind', 'true');}, 5000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber06").setAttribute('set_bind', 'true');}, 6000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber07").setAttribute('set_bind', 'true');}, 7000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber08").setAttribute('set_bind', 'true');}, 8000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber09").setAttribute('set_bind', 'true');}, 9000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber010").setAttribute('set_bind', 'true');}, 10000);
	setTimeout(function() {document.getElementById("building__view_inside_chamber011").setAttribute('set_bind', 'true');}, 11000);
}

//-----------------------------------------------------------
// Manipulation with avatar navigation modes
// X3D node: <NavigationInfo />
//-----------------------------------------------------------
function chooseNavigModes() {
	var setup_navigmodes = document.getElementById("setup-navigmodes");
	var setup_avatar = document.getElementById("building__avatar");
	if (setup_navigmodes.value == 'any') { setup_avatar.setAttribute("type", "ANY"); }
	if (setup_navigmodes.value == 'examine') { setup_avatar.setAttribute("type", "EXAMINE"); }
	if (setup_navigmodes.value == 'fly') { setup_avatar.setAttribute("type", "FLY"); }
	if (setup_navigmodes.value == 'game') { setup_avatar.setAttribute("type", "GAME"); }
	if (setup_navigmodes.value == 'lookat') { setup_avatar.setAttribute("type", "LOOKAT"); }
	if (setup_navigmodes.value == 'none') { setup_avatar.setAttribute("type", "NONE"); }
	if (setup_navigmodes.value == 'turntable') {
		setup_avatar.setAttribute("type", "TURNTABLE");
		setup_avatar.setAttribute("typeParams", "0.0 0.0 0.2 1.4");
	}
	if (setup_navigmodes.value == 'walk') { setup_avatar.setAttribute("type", "WALK"); }
}

//-----------------------------------------------------------
// Manipulation with avatar transition types between viewpoints
// X3D node: <NavigationInfo />
//-----------------------------------------------------------
function chooseTransTypes() {
	var setup_transtypes = document.getElementById("setup-transtypes");
	var avatar_transtypes = document.getElementById("building__avatar");
	if (setup_transtypes.value == 'animate') { avatar_transtypes.setAttribute("transitionType", "ANIMATE"); }
	if (setup_transtypes.value == 'linear') { avatar_transtypes.setAttribute("transitionType", "LINEAR"); }
	if (setup_transtypes.value == 'teleport') { avatar_transtypes.setAttribute("transitionType", "TELEPORT"); }
}

//-----------------------------------------------------------
// Manipulation with avatar walking speed
// X3D node: <NavigationInfo />
//-----------------------------------------------------------
function chooseAvatarSpeed() {
	var setup_speed = document.getElementById("setup-speed");
	var avatar_speed = document.getElementById("building__avatar");
	if (setup_speed.value == 'zero_two') { avatar_speed.setAttribute("speed", "0.2"); }
	if (setup_speed.value == 'zero_five') { avatar_speed.setAttribute("speed", "0.5"); }
	if (setup_speed.value == 'one_zero') { avatar_speed.setAttribute("speed", "1.0"); }
}

//-----------------------------------------------------------
// Manipulation with avatar size
// X3D node: <NavigationInfo />
//-----------------------------------------------------------
function chooseAvatarSize() {
	var setup_size = document.getElementById("setup-size");
	var avatar_size = document.getElementById("building__avatar");
	if (setup_size.value == 'human') { avatar_size.setAttribute("avatarSize", "0.25 1.6 0.8"); }
	if (setup_size.value == 'dwarf') { avatar_size.setAttribute("avatarSize", "0.2 0.9 0.4"); }
	if (setup_size.value == 'point') { avatar_size.setAttribute("avatarSize", "0.1 0.2 0.1"); }
}

jQuery(document).ready(function() {

	//-----------------------------------------------------------
	// Switching single menu tabs
	//-----------------------------------------------------------
    jQuery('.tabs .tab-links a').on('click', function(e)  {
        var currentAttrValue = jQuery(this).attr('href');		 	
        jQuery('.tabs ' + currentAttrValue).toggle(500).siblings().hide();		
        jQuery(this).parent('li').addClass('active').siblings().removeClass('active');	
        e.preventDefault();
    });

    //-----------------------------------------------------------
	// Making text bold while switching single viewpoints
	//-----------------------------------------------------------
	$('.list button').click( function() {
	    $(this).addClass('bold').siblings().removeClass('bold');
	});

	//-----------------------------------------------------------
	// Avatar headlight manipulation (on/off)
	// X3D node: <NavigationInfo />
	//-----------------------------------------------------------
	jQuery('.setup-light').click(function()  {
		if ($("#setup-light").is(":checked")) {
			document.getElementById("building__avatar").setAttribute('headlight', 'true');
		} else {
			document.getElementById("building__avatar").setAttribute('headlight', 'false');
		}
	});	

	//-----------------------------------------------------------
	// Switching visibility of single tokamak's components
	// X3D node: <Switch />
	//-----------------------------------------------------------
    jQuery('.tabs .tab-links a').on('click', function(e)  {
		// -------------------------------------------------------------------------------
		// inicialization of each tokamak component's node Switch
		// -------------------------------------------------------------------------------
		var switch_checkbox_bigcrossN = document.getElementById("tokamak__switch-bigcrossN");
		var switch_checkbox_bigcrossS = document.getElementById("tokamak__switch-bigcrossS");
		var switch_checkbox_chamber = document.getElementById("tokamak__switch-chamber");
		var switch_checkbox_coilsconnection = document.getElementById("tokamak__switch-coilsconnection");
		var switch_checkbox_interferwave = document.getElementById("tokamak__switch-interferwave");
		var switch_checkbox_magelectrons = document.getElementById("tokamak__switch-magelectrons");
		var switch_checkbox_stand = document.getElementById("tokamak__switch-stand");
		var switch_checkbox_smallcrossE = document.getElementById("tokamak__switch-smallcrossE");
		var switch_checkbox_smallcrossN = document.getElementById("tokamak__switch-smallcrossN");
		var switch_checkbox_smallcrossS = document.getElementById("tokamak__switch-smallcrossS");
		var switch_checkbox_smallcrossW = document.getElementById("tokamak__switch-smallcrossW");
		var switch_checkbox_toroidcoils = document.getElementById("tokamak__switch-toroidcoils");
		var switch_checkbox_transcoils = document.getElementById("tokamak__switch-transcoils");
		var switch_checkbox_transcore = document.getElementById("tokamak__switch-transcore");
		// -------------------------------------------------------------------------------

		var link_bigcrossN = document.getElementById("link-bigcrossN");
		var link_bigcrossS = document.getElementById("link-bigcrossS");
		var link_chamber = document.getElementById("link-chamber");
		var link_coilsconnection = document.getElementById("link-coilsconnection");
		var link_interferwave = document.getElementById("link-interferwave");
		var link_magelectrons = document.getElementById("link-magelectrons");
		var link_stand = document.getElementById("link-stand");
		var link_smallcrossE = document.getElementById("link-smallcrossE");
		var link_smallcrossN = document.getElementById("link-smallcrossN");
		var link_smallcrossS = document.getElementById("link-smallcrossS");
		var link_smallcrossW = document.getElementById("link-smallcrossW");
		var link_toroidcoils = document.getElementById("link-toroidcoils");
		var link_transcoils = document.getElementById("link-transcoils");
		var link_transcore = document.getElementById("link-transcore");

		$(document).ready(function(){						
			$('input:checkbox').click(function() {
				// tokamak's big north cross
				if ($("#check-bigcrossN").is(":checked")) {
					link_bigcrossN.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_bigcrossN.setAttribute('whichChoice', '0');
				} else {
					link_bigcrossN.removeAttribute("href");
					switch_checkbox_bigcrossN.setAttribute('whichChoice', '-1');
				}
				// tokamak's big south cross
				if ($("#check-bigcrossS").is(":checked")) {
					link_bigcrossS.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_bigcrossS.setAttribute('whichChoice', '0');
				} else {
					link_bigcrossS.removeAttribute("href");
					switch_checkbox_bigcrossS.setAttribute('whichChoice', '-1');
				}
				// tokamak's chamber
				if ($("#check-chamber").is(":checked")) {
					link_chamber.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_chamber.setAttribute('whichChoice', '0');
				} else {
					link_chamber.removeAttribute("href");
					switch_checkbox_chamber.setAttribute('whichChoice', '-1');
				}
				// tokamak's coils connection
				if ($("#check-coilsconnection").is(":checked")) {
					link_coilsconnection.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_coilsconnection.setAttribute('whichChoice', '0');
				} else {
					link_coilsconnection.removeAttribute("href");
					switch_checkbox_coilsconnection.setAttribute('whichChoice', '-1');
				}
				// tokamak's interferometer waveguide
				if ($("#check-interferwave").is(":checked")) {
					link_interferwave.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_interferwave.setAttribute('whichChoice', '0');
				} else {
					link_interferwave.removeAttribute("href");
					switch_checkbox_interferwave.setAttribute('whichChoice', '-1');
				}
				// tokamak's toroidal field electrons
				if ($("#check-magelectrons").is(":checked")) {
					link_magelectrons.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_magelectrons.setAttribute('whichChoice', '0');
				} else {
					link_magelectrons.removeAttribute("href");
					switch_checkbox_magelectrons.setAttribute('whichChoice', '-1');
				}
				// tokamak's stand on
				if ($("#check-stand").is(":checked")) {
					link_stand.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_stand.setAttribute('whichChoice', '0');
				} else {
					link_stand.removeAttribute("href");
					switch_checkbox_stand.setAttribute('whichChoice', '-1');
				}
				// tokamak's small east cross
				if ($("#check-smallcrossE").is(":checked")) {
					link_smallcrossE.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_smallcrossE.setAttribute('whichChoice', '0');
				} else {
					link_smallcrossE.removeAttribute("href");
					switch_checkbox_smallcrossE.setAttribute('whichChoice', '-1');
				}
				// tokamak's small north cross
				if ($("#check-smallcrossN").is(":checked")) {
					link_smallcrossN.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_smallcrossN.setAttribute('whichChoice', '0');
				} else {
					link_smallcrossN.removeAttribute("href");
					switch_checkbox_smallcrossN.setAttribute('whichChoice', '-1');
				}
				// tokamak's small south cross
				if ($("#check-smallcrossS").is(":checked")) {
					link_smallcrossS.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_smallcrossS.setAttribute('whichChoice', '0');
				} else {
					link_smallcrossS.removeAttribute("href");
					switch_checkbox_smallcrossS.setAttribute('whichChoice', '-1');
				}
				// tokamak's small west cross
				if ($("#check-smallcrossW").is(":checked")) {
					link_smallcrossW.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_smallcrossW.setAttribute('whichChoice', '0');
				} else {
					link_smallcrossW.removeAttribute("href");
					switch_checkbox_smallcrossW.setAttribute('whichChoice', '-1');
				}
				// tokamak's toroidal coils
				if ($("#check-toroidcoils").is(":checked")) {
					link_toroidcoils.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_toroidcoils.setAttribute('whichChoice', '0');
				} else {
					link_toroidcoils.removeAttribute("href");
					switch_checkbox_toroidcoils.setAttribute('whichChoice', '-1');
				}
				// tokamak's transformer primary coils
				if ($("#check-transcoils").is(":checked")) {
					link_transcoils.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_transcoils.setAttribute('whichChoice', '0');
				} else {
					link_transcoils.removeAttribute("href");
					switch_checkbox_transcoils.setAttribute('whichChoice', '-1');
				}
				// tokamak's transformer core
				if ($("#check-transcore").is(":checked")) {
					link_transcore.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					switch_checkbox_transcore.setAttribute('whichChoice', '0');
				} else {
					link_transcore.removeAttribute("href");
					switch_checkbox_transcore.setAttribute('whichChoice', '-1');
				}
			});
						
			// Checking fo checked checkbox All
			$("#check-all").click(function () {
			    $('input:checkbox').not(this).prop('checked', this.checked);
				if ($("#check-all").is( ":checked" )) {
					// setting external link to single tokamak's component
				   	link_bigcrossN.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_bigcrossS.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_chamber.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_coilsconnection.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_interferwave.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_magelectrons.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_stand.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_smallcrossE.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_smallcrossN.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_smallcrossS.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_smallcrossW.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_toroidcoils.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_transcoils.setAttribute("href", "http://golem.fjfi.cvut.cz/");
					link_transcore.setAttribute("href", "http://golem.fjfi.cvut.cz/");
				    // switching on visibility of components
				    switch_checkbox_bigcrossN.setAttribute('whichChoice', '0');
					switch_checkbox_bigcrossS.setAttribute('whichChoice', '0');
					switch_checkbox_chamber.setAttribute('whichChoice', '0');
					switch_checkbox_coilsconnection.setAttribute('whichChoice', '0');
					switch_checkbox_interferwave.setAttribute('whichChoice', '0');
					switch_checkbox_magelectrons.setAttribute('whichChoice', '0');
					switch_checkbox_stand.setAttribute('whichChoice', '0');
					switch_checkbox_smallcrossE.setAttribute('whichChoice', '0');
					switch_checkbox_smallcrossN.setAttribute('whichChoice', '0');
					switch_checkbox_smallcrossS.setAttribute('whichChoice', '0');
					switch_checkbox_smallcrossW.setAttribute('whichChoice', '0');
					switch_checkbox_toroidcoils.setAttribute('whichChoice', '0');
					switch_checkbox_transcoils.setAttribute('whichChoice', '0');
					switch_checkbox_transcore.setAttribute('whichChoice', '0');
				} else {
				   	// unsetting external link from single tokamak's component
				   	link_bigcrossN.removeAttribute("href");
					link_bigcrossS.removeAttribute("href");
					link_chamber.removeAttribute("href");
					link_coilsconnection.removeAttribute("href");
					link_interferwave.removeAttribute("href");
					link_magelectrons.removeAttribute("href");
					link_stand.removeAttribute("href");
					link_smallcrossE.removeAttribute("href");
					link_smallcrossN.removeAttribute("href");
					link_smallcrossS.removeAttribute("href");
					link_smallcrossW.removeAttribute("href");
					link_toroidcoils.removeAttribute("href");
					link_transcoils.removeAttribute("href");
					link_transcore.removeAttribute("href");
				   	// switching off visibility of components
				   	switch_checkbox_bigcrossN.setAttribute('whichChoice', '-1');
					switch_checkbox_bigcrossS.setAttribute('whichChoice', '-1');
					switch_checkbox_chamber.setAttribute('whichChoice', '-1');
					switch_checkbox_coilsconnection.setAttribute('whichChoice', '-1');
					switch_checkbox_interferwave.setAttribute('whichChoice', '-1');
					switch_checkbox_magelectrons.setAttribute('whichChoice', '-1');
					switch_checkbox_stand.setAttribute('whichChoice', '-1');
					switch_checkbox_smallcrossE.setAttribute('whichChoice', '-1');
					switch_checkbox_smallcrossN.setAttribute('whichChoice', '-1');
					switch_checkbox_smallcrossS.setAttribute('whichChoice', '-1');
					switch_checkbox_smallcrossW.setAttribute('whichChoice', '-1');
					switch_checkbox_toroidcoils.setAttribute('whichChoice', '-1');
					switch_checkbox_transcoils.setAttribute('whichChoice', '-1');
					switch_checkbox_transcore.setAttribute('whichChoice', '-1');
				}			    
			});
		});				
	});
});	
